import java.awt.Button;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.InterfaceAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.UnknownHostException;


@SuppressWarnings("serial")
public class FES1_App extends Frame implements WindowListener {
	private FES1UI _ui;
	
	private FES1_App() {
		_ui = new FES1UI();
		add("Center", _ui);
		setTitle("FES1 Application");
		addWindowListener(this);
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FES1_App app = new FES1_App();
		app.setLocation(200, 200);
		app.setVisible(true);
		//app.pack();
		app.setSize(app._ui.getComponentMaxWidth()+15,app._ui.getComponentMaxHeight()+72);
	}


	@Override
	public void windowActivated(WindowEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void windowClosed(WindowEvent e) {
		System.exit(0);
	}

	@Override
	public void windowClosing(WindowEvent e) {
		System.runFinalization();
		this.dispose();
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void windowDeiconified(WindowEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void windowIconified(WindowEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void windowOpened(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	
}

@SuppressWarnings("serial")
class FES1UI extends Panel {
	private static final String DISCOVER = "Discovery ?";
	private static int portSearch = 30303;
	static int length = 256; // Lnge eines Packets

	private Label lblBroadIP;
	private TextField tfIPAdress;
	private Button bBroadcast;
	private TextArea tAsearchResults;

	private LeseThreadApplet lt;
	private boolean threadIsSet = false;
	
	private DatagramSocket socket;

	public FES1UI() {
		lblBroadIP = new Label("Broadcast-Address:");
		add(lblBroadIP);
		tfIPAdress = new TextField("255.255.255.255",11);
		add(tfIPAdress);
		bBroadcast = new Button("find FES1");
		bBroadcast.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				// send the Message and display what comes back in
				// the textArea
				String ip = tfIPAdress.getText().trim();
				boolean isOK = false;
				ip = correctIpAddress(ip);
				tfIPAdress.setText(ip);
				doSearchNetwork(ip);
			}
		});
		add(bBroadcast);
		tAsearchResults = new TextArea(5, 64);
		add(tAsearchResults);
	}
	
	private String correctIpAddress(String ip) {
		// check for "correct" IP-Address
		String trmIP = ip.trim();
		String [] strVals = trmIP.split("\\.");
		String goodIP = "";
		boolean isOK = true;
		if (strVals.length == 4) {
			for (int i = 0; i < strVals.length; i++) {
				String gp = strVals[i].trim();
				int gI = Integer.valueOf(gp);
				if (i==0) {
					goodIP = goodIP + gp + ".";
					if (gI < 1 || gI > 255) isOK = false;
				} else if (i < 3) {
					goodIP = goodIP + gp + ".";
					if (gI < 0 || gI > 255) isOK = false;
				} else {
					goodIP = goodIP + gp;
					if (gI < 1 || gI > 255) isOK = false;
				}
			}
		} else {
			isOK = false;
		}
		if (isOK) return goodIP;
		else return "255.255.255.255";
	}
	
	
	public int getComponentMaxWidth() {
		int size = 0;
		int max = 0;
		for (int i = 0; i < getComponentCount(); i++) {
			size = getComponents()[i].getWidth();
			if (size > max) {
				max = size;
			}
		}
		return max;
	}
	
	public int getComponentMaxHeight() {
		int size = 0;
		int max = 0;
		for (int i = 0; i < getComponentCount(); i++) {
			size = getComponents()[i].getHeight();
			if (size > max) {
				max = size;
			}
		}
		return max;
	}
	
	public void doSearchNetwork( String IP ) {
		String servername = IP;
		DatagramPacket packet;
		byte[] ba = DISCOVER.getBytes();

		try {
			if (socket == null) {
				socket = new DatagramSocket();
			}
			InetAddress ia = InetAddress.getByName( servername );
			packet = new DatagramPacket( ba, ba.length, ia, portSearch );

			tAsearchResults.setText("Keine Netzwerk-Verbindung vorhanden!");
			// sende Suchanfrage
			socket.send( packet );

			tAsearchResults.setText("Verbindung?");
			// Lesen der empfangenen Pakete erfolgt in eigenem Thread
			if ( threadIsSet == false ) {
				lt = new LeseThreadApplet( socket, tAsearchResults );
				threadIsSet = true;
			} else {
				lt.clearAnswers();
				tAsearchResults.setText("Verbindung? (Netzwerk vorhanden?) Broadcast-Adresse?");
			}

		} catch (IOException e) {
			System.err.println("Ausnahmefehler: " + e);
			tAsearchResults.setText("Keine Netzwerk-Verbindung vorhanden!");
			//threadIsSet = false;
		}

	}
	
}

class LeseThreadApplet implements Runnable {
	static int length = 256;
	private DatagramSocket socket;
	private TextArea tAoutput;
	private String answers;
	private Thread t;

	LeseThreadApplet(DatagramSocket socket, TextArea tAsearchResults ) {
		this.socket = socket;
		tAoutput = tAsearchResults;
		answers = "";
		t = new Thread(this,"Lesen");
		t.start();
	}
	
	public void clearAnswers() {
		answers = "";
	}

	@Override
	public void run() {
		DatagramPacket packet = new DatagramPacket(new byte[length], length);
		while( true ) {
			try {
				socket.receive( packet );
				// InetSocketAddress add = (InetSocketAddress) packet.getSocketAddress();
				String text = new String(packet.getData(), 0, packet.getLength());
				String [] textSplt = text.split("\r\n");
				String ipAddrStr = packet.getAddress().getHostAddress();
				String node = "";
				node = ipAddrStr;
				for (int i = 0; i < textSplt.length; i++){
					if (i == 1) node = node + " > MAC: " + textSplt[i].trim();
					else node = node + " > " + textSplt[i].trim();
				}
				answers = answers + node + "\r\n";
				tAoutput.setText(answers);
				System.out.println(node);

			} catch ( IOException e ) {
				System.err.println("Ausnahmefehler: " + e);
			}
		}
	}

}